poj 2955(区间DP)

2024-08-24 16:08
文章标签 dp poj 区间 2955

本文主要是介绍poj 2955(区间DP),希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

Language:

Brackets

Time Limit: 1000MS

 

Memory Limit: 65536K

Total Submissions: 2394

 

Accepted: 1233

Description

We give the following inductive definition of a “regular brackets” sequence:

  • the empty sequence is a regular brackets sequence,
  • if s is a regular brackets sequence, then (s) and [s] are regular brackets sequences, and
  • if a and b are regular brackets sequences, then ab is a regular brackets sequence.
  • no other sequence is a regular brackets sequence

For instance, all of the following character sequences are regular brackets sequences:

(), [], (()), ()[], ()[()]

while the following character sequences are not:

(, ], )(, ([)], ([(]

Given a brackets sequence of characters a1a2 … an, your goal is to find the length of the longest regular brackets sequence that is a subsequence of s. That is, you wish to find the largest m such that for indices i1,i2, …, im where 1 ≤ i1 < i2 < … < im ≤ nai1ai2 … aim is a regular brackets sequence.

Given the initial sequence ([([]])], the longest regular brackets subsequence is [([])].

Input

The input test file will contain multiple test cases. Each input test case consists of a single line containing only the characters ()[, and ]; each input test will have length between 1 and 100, inclusive. The end-of-file is marked by a line containing the word “end” and should not be processed.

Output

For each input case, the program should print the length of the longest possible regular brackets subsequence on a single line.

Sample Input

((()))()()()([]]))[)(([][][)end

Sample Output

66406

 

题解:

题意:在一些括号中找到一个序列,里面的括号都两两配对。求序列最长长度。

区间DP,dp[i][j]为i~j的最大括号数,考虑第i个括号,有两种情况:

1.不管i直接算dp[i + 1][j];

2.找到和i匹配的右括号,分两边算并加起来.dp[i][j] = dp[i + 1][k - 1] + 2 + dp[k + 1][j]。

我在这里就吃了一个大亏:我一直认为只有s[i]不为"("和"["时候才匹配第一种情况,

其实不是,考虑这种情况"([]",当s[i]等于'('时候,依旧要在第一种和第二种情况中取最大的.

综合一下就是无论什么情况,都要算第一种和第二种而且是取他们中最大的.

 

这是我的错误程序,留作纪念:这里的重点是添加了一个自动测试语句,检测正确的程序和我的程序在那个用例上输出不一致.

#include <iostream>
#include <string>
#include <time.h>
using namespace std;
#define Max 300
int dp[Max][Max];
int dp123[205][205];//表示从i到j的最大匹配。
bool match(int i,int j,const string &str)
{
if((str[i]=='('&&str[j]==')')||(str[i]=='['&&str[j]==']'))
return true;
else return false;
}
int maxi(int a,int b)
{
if(a>b)
return a;
else return b;
}
int dpf(const string &str)
{
int i,j,k,len,g;
/* if(str[0]=='e'&&str[1]=='n'&&str[2]=='d')
return 0;*/
memset(dp123,0,sizeof(dp123));
len=str.size();
for(i=1;i<len;i++)
{//初始化从i到i+1这个的dp
if(match(i-1,i,str)==true)
dp123[i][i+1]=1;
}
for(i=3;i<=len;i++)
for(j=1;j<=len-i+1;j++)
{
k=j+i-1;
//这一步是必须得,这个相当于是最后一个和第一个匹配,然后找中间的最大匹配
//这个状态下面的for覆盖不了,必须单独判断一下
if(match(j-1,k-1,str)==true)
dp123[j][k]=dp123[j+1][k-1]+1;
//这个相当于是从j开始找到一个位置的最大匹配加上从这个位置到k的最大匹配
//有点分治法的味道。
for(g=0;g<k;g++)
dp123[j][k]=maxi(dp123[j][k],dp123[j][j+g]+dp123[j+g+1][k]);
}
return dp123[1][len]*2;
}
int dpfunc(const string &s){
memset(dp,0,sizeof(dp));
int len = s.length();
if (len==0) return 0;
for ( int step=1; step<len; ++step ){
for (int i=0; i<len-step; ++i ) {
if ( s[i]!='(' && s[i]!='[' ) {
dp[i][i+step] = dp[i+1][i+step];
continue;
}
int max =0;
for ( int k=i+1,j=i+step; k<=j; ++k ){
if (!((s[i]=='(' && s[k]==')') ||(s[i]=='[' && s[k]==']'))) continue;
int temp = dp[i+1][k-1]+dp[k+1][j]+2;//在这里k有可能大于j,由于当k>j时候dp全部为0,所以也会成立
max = max >temp ? max : temp;
}
dp[i][i+step] = max;
}
}
return dp[0][len-1];
}
int main()
{
char ch[4]={'[',']','(',')'};
srand( (unsigned)time( NULL ) );
char c[50];
int len = rand()%50;
// cin>>s;
while (true){
for ( int i=0; i<len; ++i ){
int index = rand()%4;
c[i]=ch[index];
}
c[len]= '\0';
string s(c);
if(s[0]=='e'&&s[1]=='n'&&s[2]=='d')
break;
//cout<<dpfunc(s)<<endl;
if (dpfunc(s)!=dpf(s)){
cout<<s<<endl;
cout<<dpfunc(s)<<"   "<<dpf(s)<<endl;
break;
}
}
return 0;
}

ac的程序:

#include <iostream>
#include <string>
#include <time.h>
using namespace std;
#define Max 300
int dp[Max][Max];
int dpfunc(const string &s){
memset(dp,0,sizeof(dp));
int len = s.length();
if (len==0) return 0;
for ( int step=1; step<len; ++step ){
for (int i=0; i<len-step; ++i ) {
int max = dp[i+1][i+step];
for ( int k=i+1,j=i+step; k<=j; ++k ){
if (!((s[i]=='(' && s[k]==')') ||(s[i]=='[' && s[k]==']'))) continue;
int temp = dp[i+1][k-1]+dp[k+1][j]+2;//在这里k有可能大于j,由于当k>j时候dp全部为0,所以也会成立
max = max >temp ? max : temp;
}
dp[i][i+step] = max;
}
}
return dp[0][len-1];
}
int main()
{
string s;
cin>>s;
while (s!="end"){
cout<<dpfunc(s)<<endl;
cin>>s;    
}
return 0;
}

 

 

这篇关于poj 2955(区间DP)的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/1102955

相关文章

hdu4826(三维DP)

这是一个百度之星的资格赛第四题 题目链接:http://acm.hdu.edu.cn/contests/contest_showproblem.php?pid=1004&cid=500 题意:从左上角的点到右上角的点,每个点只能走一遍,走的方向有三个:向上,向下,向右,求最大值。 咋一看像搜索题,先暴搜,TLE,然后剪枝,还是TLE.然后我就改方法,用DP来做,这题和普通dp相比,多个个向上

hdu1011(背包树形DP)

没有完全理解这题, m个人,攻打一个map,map的入口是1,在攻打某个结点之前要先攻打其他一个结点 dp[i][j]表示m个人攻打以第i个结点为根节点的子树得到的最优解 状态转移dp[i][ j ] = max(dp[i][j], dp[i][k]+dp[t][j-k]),其中t是i结点的子节点 代码如下: #include<iostream>#include<algorithm

hdu4865(概率DP)

题意:已知前一天和今天的天气概率,某天的天气概率和叶子的潮湿程度的概率,n天叶子的湿度,求n天最有可能的天气情况。 思路:概率DP,dp[i][j]表示第i天天气为j的概率,状态转移如下:dp[i][j] = max(dp[i][j, dp[i-1][k]*table2[k][j]*table1[j][col] )  代码如下: #include <stdio.h>#include

usaco 1.1 Broken Necklace(DP)

直接上代码 接触的第一道dp ps.大概的思路就是 先从左往右用一个数组在每个点记下蓝或黑的个数 再从右到左算一遍 最后取出最大的即可 核心语句在于: 如果 str[i] = 'r'  ,   rl[i]=rl[i-1]+1, bl[i]=0 如果 str[i] = 'b' ,  bl[i]=bl[i-1]+1, rl[i]=0 如果 str[i] = 'w',  bl[i]=b

poj 3974 and hdu 3068 最长回文串的O(n)解法(Manacher算法)

求一段字符串中的最长回文串。 因为数据量比较大,用原来的O(n^2)会爆。 小白上的O(n^2)解法代码:TLE啦~ #include<stdio.h>#include<string.h>const int Maxn = 1000000;char s[Maxn];int main(){char e[] = {"END"};while(scanf("%s", s) != EO

hdu 2602 and poj 3624(01背包)

01背包的模板题。 hdu2602代码: #include<stdio.h>#include<string.h>const int MaxN = 1001;int max(int a, int b){return a > b ? a : b;}int w[MaxN];int v[MaxN];int dp[MaxN];int main(){int T;int N, V;s

poj 1511 Invitation Cards(spfa最短路)

题意是给你点与点之间的距离,求来回到点1的最短路中的边权和。 因为边很大,不能用原来的dijkstra什么的,所以用spfa来做。并且注意要用long long int 来存储。 稍微改了一下学长的模板。 stack stl 实现代码: #include<stdio.h>#include<stack>using namespace std;const int M

poj 3259 uva 558 Wormholes(bellman最短路负权回路判断)

poj 3259: 题意:John的农场里n块地,m条路连接两块地,w个虫洞,虫洞是一条单向路,不但会把你传送到目的地,而且时间会倒退Ts。 任务是求你会不会在从某块地出发后又回来,看到了离开之前的自己。 判断树中是否存在负权回路就ok了。 bellman代码: #include<stdio.h>const int MaxN = 501;//农场数const int

poj 1258 Agri-Net(最小生成树模板代码)

感觉用这题来当模板更适合。 题意就是给你邻接矩阵求最小生成树啦。~ prim代码:效率很高。172k...0ms。 #include<stdio.h>#include<algorithm>using namespace std;const int MaxN = 101;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int n

poj 1287 Networking(prim or kruscal最小生成树)

题意给你点与点间距离,求最小生成树。 注意点是,两点之间可能有不同的路,输入的时候选择最小的,和之前有道最短路WA的题目类似。 prim代码: #include<stdio.h>const int MaxN = 51;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int P;int prim(){bool vis[MaxN];